<?php
/**
 * CartUpsellAfter
 *
 * PHP version 5
 *
 * @category Class
 * @package  ultracart\v2
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * UltraCart Rest API V2
 *
 * UltraCart REST API Version 2
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@ultracart.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace ultracart\v2\models;

use \ArrayAccess;
use \ultracart\v2\ObjectSerializer;

/**
 * CartUpsellAfter Class Doc Comment
 *
 * @category Class
 * @package  ultracart\v2
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CartUpsellAfter implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'CartUpsellAfter';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'finalize_after_dts' => 'string',
        'finalize_after_minutes' => 'int',
        'upsell_path_code' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'finalize_after_dts' => 'dateTime',
        'finalize_after_minutes' => 'int32',
        'upsell_path_code' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'finalize_after_dts' => 'finalize_after_dts',
        'finalize_after_minutes' => 'finalize_after_minutes',
        'upsell_path_code' => 'upsell_path_code'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'finalize_after_dts' => 'setFinalizeAfterDts',
        'finalize_after_minutes' => 'setFinalizeAfterMinutes',
        'upsell_path_code' => 'setUpsellPathCode'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'finalize_after_dts' => 'getFinalizeAfterDts',
        'finalize_after_minutes' => 'getFinalizeAfterMinutes',
        'upsell_path_code' => 'getUpsellPathCode'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['finalize_after_dts'] = isset($data['finalize_after_dts']) ? $data['finalize_after_dts'] : null;
        $this->container['finalize_after_minutes'] = isset($data['finalize_after_minutes']) ? $data['finalize_after_minutes'] : null;
        $this->container['upsell_path_code'] = isset($data['upsell_path_code']) ? $data['upsell_path_code'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['upsell_path_code']) && (mb_strlen($this->container['upsell_path_code']) > 5)) {
            $invalidProperties[] = "invalid value for 'upsell_path_code', the character length must be smaller than or equal to 5.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (mb_strlen($this->container['upsell_path_code']) > 5) {
            return false;
        }
        return true;
    }


    /**
     * Gets finalize_after_dts
     *
     * @return string
     */
    public function getFinalizeAfterDts()
    {
        return $this->container['finalize_after_dts'];
    }

    /**
     * Sets finalize_after_dts
     *
     * @param string $finalize_after_dts The date/time after which the cart will finalize into an order.
     *
     * @return $this
     */
    public function setFinalizeAfterDts($finalize_after_dts)
    {
        $this->container['finalize_after_dts'] = $finalize_after_dts;

        return $this;
    }

    /**
     * Gets finalize_after_minutes
     *
     * @return int
     */
    public function getFinalizeAfterMinutes()
    {
        return $this->container['finalize_after_minutes'];
    }

    /**
     * Sets finalize_after_minutes
     *
     * @param int $finalize_after_minutes The amount of inactivity in minutes after which the cart should be finalized into an order.  This will calculate the finalize_after_dts field.
     *
     * @return $this
     */
    public function setFinalizeAfterMinutes($finalize_after_minutes)
    {
        $this->container['finalize_after_minutes'] = $finalize_after_minutes;

        return $this;
    }

    /**
     * Gets upsell_path_code
     *
     * @return string
     */
    public function getUpsellPathCode()
    {
        return $this->container['upsell_path_code'];
    }

    /**
     * Sets upsell_path_code
     *
     * @param string $upsell_path_code Upsell path code
     *
     * @return $this
     */
    public function setUpsellPathCode($upsell_path_code)
    {
        if (!is_null($upsell_path_code) && (mb_strlen($upsell_path_code) > 5)) {
            throw new \InvalidArgumentException('invalid length for $upsell_path_code when calling CartUpsellAfter., must be smaller than or equal to 5.');
        }

        $this->container['upsell_path_code'] = $upsell_path_code;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


