<?php
/**
 * ItemShippingCase
 *
 * PHP version 5
 *
 * @category Class
 * @package  ultracart\v2
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * UltraCart Rest API V2
 *
 * UltraCart REST API Version 2
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@ultracart.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace ultracart\v2\models;

use \ArrayAccess;
use \ultracart\v2\ObjectSerializer;

/**
 * ItemShippingCase Class Doc Comment
 *
 * @category Class
 * @package  ultracart\v2
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ItemShippingCase implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'ItemShippingCase';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'case_label' => 'string',
        'case_merchant_item_id' => 'string',
        'case_merchant_item_oid' => 'int',
        'quantity' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'case_label' => null,
        'case_merchant_item_id' => null,
        'case_merchant_item_oid' => 'int32',
        'quantity' => 'int32'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'case_label' => 'case_label',
        'case_merchant_item_id' => 'case_merchant_item_id',
        'case_merchant_item_oid' => 'case_merchant_item_oid',
        'quantity' => 'quantity'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'case_label' => 'setCaseLabel',
        'case_merchant_item_id' => 'setCaseMerchantItemId',
        'case_merchant_item_oid' => 'setCaseMerchantItemOid',
        'quantity' => 'setQuantity'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'case_label' => 'getCaseLabel',
        'case_merchant_item_id' => 'getCaseMerchantItemId',
        'case_merchant_item_oid' => 'getCaseMerchantItemOid',
        'quantity' => 'getQuantity'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['case_label'] = isset($data['case_label']) ? $data['case_label'] : null;
        $this->container['case_merchant_item_id'] = isset($data['case_merchant_item_id']) ? $data['case_merchant_item_id'] : null;
        $this->container['case_merchant_item_oid'] = isset($data['case_merchant_item_oid']) ? $data['case_merchant_item_oid'] : null;
        $this->container['quantity'] = isset($data['quantity']) ? $data['quantity'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['case_label']) && (mb_strlen($this->container['case_label']) > 20)) {
            $invalidProperties[] = "invalid value for 'case_label', the character length must be smaller than or equal to 20.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (mb_strlen($this->container['case_label']) > 20) {
            return false;
        }
        return true;
    }


    /**
     * Gets case_label
     *
     * @return string
     */
    public function getCaseLabel()
    {
        return $this->container['case_label'];
    }

    /**
     * Sets case_label
     *
     * @param string $case_label Case label
     *
     * @return $this
     */
    public function setCaseLabel($case_label)
    {
        if (!is_null($case_label) && (mb_strlen($case_label) > 20)) {
            throw new \InvalidArgumentException('invalid length for $case_label when calling ItemShippingCase., must be smaller than or equal to 20.');
        }

        $this->container['case_label'] = $case_label;

        return $this;
    }

    /**
     * Gets case_merchant_item_id
     *
     * @return string
     */
    public function getCaseMerchantItemId()
    {
        return $this->container['case_merchant_item_id'];
    }

    /**
     * Sets case_merchant_item_id
     *
     * @param string $case_merchant_item_id Case item id
     *
     * @return $this
     */
    public function setCaseMerchantItemId($case_merchant_item_id)
    {
        $this->container['case_merchant_item_id'] = $case_merchant_item_id;

        return $this;
    }

    /**
     * Gets case_merchant_item_oid
     *
     * @return int
     */
    public function getCaseMerchantItemOid()
    {
        return $this->container['case_merchant_item_oid'];
    }

    /**
     * Sets case_merchant_item_oid
     *
     * @param int $case_merchant_item_oid Case item object identifier
     *
     * @return $this
     */
    public function setCaseMerchantItemOid($case_merchant_item_oid)
    {
        $this->container['case_merchant_item_oid'] = $case_merchant_item_oid;

        return $this;
    }

    /**
     * Gets quantity
     *
     * @return int
     */
    public function getQuantity()
    {
        return $this->container['quantity'];
    }

    /**
     * Sets quantity
     *
     * @param int $quantity Case quantity
     *
     * @return $this
     */
    public function setQuantity($quantity)
    {
        $this->container['quantity'] = $quantity;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


