<?php
/**
 * TempMultimedia
 *
 * PHP version 5
 *
 * @category Class
 * @package  ultracart\v2
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * UltraCart Rest API V2
 *
 * UltraCart REST API Version 2
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@ultracart.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace ultracart\v2\models;

use \ArrayAccess;
use \ultracart\v2\ObjectSerializer;

/**
 * TempMultimedia Class Doc Comment
 *
 * @category Class
 * @package  ultracart\v2
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class TempMultimedia implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'TempMultimedia';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'filename' => 'string',
        'height' => 'int',
        'multimedia_type' => 'string',
        'size' => 'int',
        'temp_multimedia_oid' => 'int',
        'url' => 'string',
        'width' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'filename' => null,
        'height' => 'int32',
        'multimedia_type' => null,
        'size' => 'int64',
        'temp_multimedia_oid' => 'int32',
        'url' => null,
        'width' => 'int32'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'filename' => 'filename',
        'height' => 'height',
        'multimedia_type' => 'multimedia_type',
        'size' => 'size',
        'temp_multimedia_oid' => 'temp_multimedia_oid',
        'url' => 'url',
        'width' => 'width'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'filename' => 'setFilename',
        'height' => 'setHeight',
        'multimedia_type' => 'setMultimediaType',
        'size' => 'setSize',
        'temp_multimedia_oid' => 'setTempMultimediaOid',
        'url' => 'setUrl',
        'width' => 'setWidth'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'filename' => 'getFilename',
        'height' => 'getHeight',
        'multimedia_type' => 'getMultimediaType',
        'size' => 'getSize',
        'temp_multimedia_oid' => 'getTempMultimediaOid',
        'url' => 'getUrl',
        'width' => 'getWidth'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const MULTIMEDIA_TYPE_IMAGE = 'Image';
    const MULTIMEDIA_TYPE_PDF = 'PDF';
    const MULTIMEDIA_TYPE_TEXT = 'Text';
    const MULTIMEDIA_TYPE_VIDEO = 'Video';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getMultimediaTypeAllowableValues()
    {
        return [
            self::MULTIMEDIA_TYPE_IMAGE,
            self::MULTIMEDIA_TYPE_PDF,
            self::MULTIMEDIA_TYPE_TEXT,
            self::MULTIMEDIA_TYPE_VIDEO,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['filename'] = isset($data['filename']) ? $data['filename'] : null;
        $this->container['height'] = isset($data['height']) ? $data['height'] : null;
        $this->container['multimedia_type'] = isset($data['multimedia_type']) ? $data['multimedia_type'] : null;
        $this->container['size'] = isset($data['size']) ? $data['size'] : null;
        $this->container['temp_multimedia_oid'] = isset($data['temp_multimedia_oid']) ? $data['temp_multimedia_oid'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['width'] = isset($data['width']) ? $data['width'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['filename']) && (mb_strlen($this->container['filename']) > 75)) {
            $invalidProperties[] = "invalid value for 'filename', the character length must be smaller than or equal to 75.";
        }

        $allowedValues = $this->getMultimediaTypeAllowableValues();
        if (!in_array($this->container['multimedia_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'multimedia_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (mb_strlen($this->container['filename']) > 75) {
            return false;
        }
        $allowedValues = $this->getMultimediaTypeAllowableValues();
        if (!in_array($this->container['multimedia_type'], $allowedValues)) {
            return false;
        }
        return true;
    }


    /**
     * Gets filename
     *
     * @return string
     */
    public function getFilename()
    {
        return $this->container['filename'];
    }

    /**
     * Sets filename
     *
     * @param string $filename Filename
     *
     * @return $this
     */
    public function setFilename($filename)
    {
        if (!is_null($filename) && (mb_strlen($filename) > 75)) {
            throw new \InvalidArgumentException('invalid length for $filename when calling TempMultimedia., must be smaller than or equal to 75.');
        }

        $this->container['filename'] = $filename;

        return $this;
    }

    /**
     * Gets height
     *
     * @return int
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param int $height Height
     *
     * @return $this
     */
    public function setHeight($height)
    {
        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets multimedia_type
     *
     * @return string
     */
    public function getMultimediaType()
    {
        return $this->container['multimedia_type'];
    }

    /**
     * Sets multimedia_type
     *
     * @param string $multimedia_type Multimedia type
     *
     * @return $this
     */
    public function setMultimediaType($multimedia_type)
    {
        $allowedValues = $this->getMultimediaTypeAllowableValues();
        if (!is_null($multimedia_type) && !in_array($multimedia_type, $allowedValues)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'multimedia_type', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['multimedia_type'] = $multimedia_type;

        return $this;
    }

    /**
     * Gets size
     *
     * @return int
     */
    public function getSize()
    {
        return $this->container['size'];
    }

    /**
     * Sets size
     *
     * @param int $size Size
     *
     * @return $this
     */
    public function setSize($size)
    {
        $this->container['size'] = $size;

        return $this;
    }

    /**
     * Gets temp_multimedia_oid
     *
     * @return int
     */
    public function getTempMultimediaOid()
    {
        return $this->container['temp_multimedia_oid'];
    }

    /**
     * Sets temp_multimedia_oid
     *
     * @param int $temp_multimedia_oid Temporary multimedia object identifier
     *
     * @return $this
     */
    public function setTempMultimediaOid($temp_multimedia_oid)
    {
        $this->container['temp_multimedia_oid'] = $temp_multimedia_oid;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url URL
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets width
     *
     * @return int
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param int $width Width
     *
     * @return $this
     */
    public function setWidth($width)
    {
        $this->container['width'] = $width;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


